/* 
 * File: sdecode.c
 *
 * Copyright (c) 2005 Johannes Heimansberg
 *
 * Released under the GNU General Public License v2
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>

gchar hex2char(gchar first_digit, gchar second_digit)
{
	gchar result = 0;
	
	if (first_digit >= '0' && first_digit <= '9')
		result = (first_digit - '0') * 16;
	else if (first_digit >= 'a' && first_digit <= 'f')
		result = (first_digit - 'a' + 10) * 16;
	if (second_digit >= '0' && second_digit <= '9')
		result += second_digit - '0';
	else if (second_digit >= 'a' && second_digit <= 'f')
		result += second_digit - 'a' + 10;
	return result;
}

gchar *decode_string(gchar *string)
{
	int i, j;
	gchar *result = g_malloc((strlen(string) + 1) * sizeof(gchar));

	/* decode %XX escape sequences to their corresponding chars: */
	for (i = 0, j = 0; i < strlen(string); i++) {
		if (string[i] == '%') {
			result[j] = hex2char(string[i+1], string[i+2]);
			i+=2;
			j++; 
		} else {
			result[j] = string[i];
			j++;
		}
	}
	result[j] = '\0';
	return result;
}
